<?php

namespace App\Database\Migrations;

use CodeIgniter\Database\Migration;
use CodeIgniter\Database\RawSql;

class ChatDepartments extends Migration
{
    protected array $COLUMNS = [
        "id" => [
            "type" => "INT",
            "unsigned" => true,
            "auto_increment" => true
        ],
        "name" => [
            "type" => "VARCHAR",
            "constraint" => '45',
            "unique" => true,
        ],
        "display" => [
            "type" => "VARCHAR",
            "constraint" => '255',
        ],
        "description" => [
            "type" => "TEXT",
            "null" => true,
        ],
        "type" => [
            "type" => "ENUM",
            'constraint' => ['general', 'presupuesto', 'pedido'],
            'default'    => 'general',
        ],

    ];
    public function up()
    {
        $this->forge->addField($this->COLUMNS);
        $currenttime = new RawSql("CURRENT_TIMESTAMP");
        $this->forge->addField([
            "created_at" => [
                "type" => "TIMESTAMP",
                "default" => $currenttime,

            ],
            "updated_at" => [
                "type" => "TIMESTAMP",
                "null" => true,

            ],
            "deleted_at" => [
                "type" => "TIMESTAMP",
                "null" => true,

            ],
        ]);
        $this->forge->addPrimaryKey('id');
        $this->forge->createTable("chat_departments", true);
    }

    public function down()
    {
        //
        $this->forge->dropTable("chat_departments");
    }
}
